///////////////////////////////////////////////////////////////////////////////////
//KrFilterGtFNg
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;

float Tr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;
float X : CONTROLOBJECT < string name = "(self)"; string item = "X"; >;
float Y : CONTROLOBJECT < string name = "(self)"; string item = "Y"; >;
float Z : CONTROLOBJECT < string name = "(self)"; string item = "Z"; >;
float Rx : CONTROLOBJECT < string name = "(self)"; string item = "Rx"; >;

static float AllRate1 =X;
static float AllRate2 =Y;
static float MulRate = Z;
static float AroundDarkRate = Rx * 180 / 3.14;

float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);

float ClearDepth = 1.0;
float4 ClearColor= float4(0,0,0,0);

texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;

texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A8B8G8R8";
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}


////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_passFilter(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=tex2D(ScnSamp, Tex);
	float3 ColorB = Color.rgb;
	Color.rgb = saturate(Color);
	float3 Color2 = (Color.rgb - 0.5) * 2;
	float3 Color3 = (1.0 - pow(1.0 - abs(Color2), 2.0))*sign(Color2)*0.5 + 0.5;
	Color.rgb = lerp(Color.rgb, Color3, AllRate1);

	Color.rgb *= lerp(1.0, Color.rgb, MulRate);

	float3 Color4 = saturate(Color.rgb);

	float RRate = (Color4.r - 0.5) * 2;
	Color4.r = Color4.r*2 -(lerp(-pow(RRate, 2), pow(RRate, 2), step(0, RRate))*0.5 + 0.5);
	float BRate = (Color4.b - 0.5) * 2;
	Color4.b = lerp(-pow(BRate, 2), pow(BRate, 2), step(0, BRate))*0.5 + 0.5;

	Color.rgb = lerp(Color.rgb, Color4, AllRate2);

	float AroundPosRate = saturate(pow(1.2 - length(Tex - 0.5), 2));
	Color.rgb = lerp(Color.rgb, Color.rgb *AroundPosRate, AroundDarkRate);
	Color.rgb = lerp(ColorB, Color.rgb, Tr);

	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////

technique FILTER <
	string Script =

	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"

	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=Filter;"

	;

> {
	pass Filter < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passFilter();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
